#pragma once

//i don't know if its really worth the time, but I think a qued message dispatcher will make the gameflow
//a lot easier to do..

#include "main.h"
#include <list>
using namespace std;

enum
{
  C_MESSAGE_KILL_ENTITY,
  C_MESSAGE_SOUND,
  C_MESSAGE_TEXT,
  C_MESSAGE_REINCARNATE,
  C_MESSAGE_FADE_OUT_AND_DIE,
  C_MESSAGE_ADD_TILE,
  C_MESSAGE_INIT_END_LEVEL_TEXT,
  C_MESSAGE_RESTART

};

class Entity;

class Message
{
public:

    Message()
    {
        m_bDeleteRequest = false;
        m_pDeliveryTarget = NULL;
        m_deliveryTime = 0;
		m_parm = 0;
		m_parm1 = 0;
		m_pParmEnt = 0;
    }



    int m_msg;
    Entity *m_pDeliveryTarget; //null if none
    CL_Vector2 m_pos;
	unsigned int m_deliveryTime;
    bool m_bDeleteRequest;
    string m_text;
	int m_parm;
	int m_parm1;
	Entity *m_pParmEnt;
	CL_Vector2 m_parmVec;

};

class MessageDispatcher
{
public:

    void SendMsg(int message, int deliveryTimeMS, Entity *pEnt = NULL, int parm = 0);
    void SendMsgEx(Message &msg, int deliveryTimeMS);

	void DeliverMsg(Message &msg);
    void Update();
    void ClearAllMessages();
    void SendText(std::string text, int deliveryTime, int delayTime=0, CL_Vector2 vPos=CL_Vector2(0,300));
    void KillAllMessagesToThisEnt(Entity *pEnt); //avoid crashes..
    void KillMessageType(int msg); 

private:

    std::list<Message> m_message;

};