
#include "Sound.h"

Sound g_Sound;
Sound::Sound()
{
}

Sound::~Sound()
{
}

//really dumb caching system, but I don't want to fool with a hashed map, won't matter anyway

SoundInfo * Sound::GetSound(string fileName)
{
	for (int i=0; i < m_soundVec.size(); i++)
	{
		if (m_soundVec[i].m_fileName == fileName)
		{
			return &m_soundVec[i];
		}
	}

	//if we got here, we need to add the sound ourselves.

	SoundInfo s;
	s.m_fileName = fileName;
	s.m_buffer = CL_SoundBuffer(fileName);
	m_soundVec.push_back(s);
	int index = m_soundVec.size()-1;
	return &m_soundVec[index];
}

void Sound::Play( string fileName )
{
	fileName = "media\\"+fileName;
	SoundInfo *pSoundInfo = GetSound(fileName);
	if (pSoundInfo)
	{
#ifdef _DEBUG
		LogMsg("Playing %s.", fileName.c_str());
#endif
		pSoundInfo->m_buffer.play();
	}
}