//  ***************************************************************
//  EntGirl - Creation date: 12/16/2007
//  -------------------------------------------------------------
//  Robinson Technologies Copyright (C) 2007 - All Rights Reserved
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef EntGirl_h__
#define EntGirl_h__
#include "Entity.h"
#include "Main.h"



class EntGirl: public Entity
{
public:
	EntGirl();
	virtual ~EntGirl();
	bool Init(int tileID);
	void Render();
	void Update(float step);
	void OnRescued();
private:

	void OnBurn();
	void SetPointIncreaseTimer();
	void ResetThinkTimer();
	enum eAnim
	{
		ANIM_IDLE = 0, //what frame to start on
		ANIM_DEAD = 2
	};

	int m_curFrame;
	int m_curAnim;
	int m_tileID;
	int m_nextFrameTimer;
	int m_animSpeedMS;
	int m_totalFramesInAnim;
	int m_pointValue;
	bool m_bHaveClearedMapTile;
	int m_pointIncreaseTimer;
	int m_timesRaised;
	int m_thinkTimer;
};

#endif // EntGirl_h__