//  ***************************************************************
//  EntObstacle - Creation date: 12/16/2007
//  -------------------------------------------------------------
//  Robinson Technologies Copyright (C) 2007 - All Rights Reserved
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef EntObstacle_h__
#define EntObstacle_h__
#include "Main.h"
#include "Entity.h"

enum eObstacleType
{
	OBSTACLE_ROCK,
	OBSTACLE_WOOD,
	OBSTACLE_WATER
};


class EntObstacle:public Entity
{
public:
	EntObstacle();
	virtual ~EntObstacle();
	bool Init(int tileID, eObstacleType type);
	void Render();
	void BurnedByFire();
	bool IsDestroyedByFire();
	void AttemptToDestroy();
	bool IsBurnable();
	bool FireCanPassThrough();
protected:
	

private:
	bool m_bDying;
	int m_tileID;
};

#endif // EntObstacle_h__