//  ***************************************************************
//  Sound - Creation date: 12/15/2007
//  -------------------------------------------------------------
//  Robinson Technologies Copyright (C) 2007 - All Rights Reserved
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef Sound_h__
#define Sound_h__

#include "main.h"


class SoundInfo
{
public:

	string m_fileName;
	CL_SoundBuffer m_buffer;
};

class Sound
{
public:
	Sound();
	virtual ~Sound();


	void Play(string fileName);

private:
	SoundInfo * GetSound(string fileName);

	vector<SoundInfo> m_soundVec;
	
};

extern Sound g_Sound;
#endif // Sound_h__